//Welcome to DotJS!
//With DotJS, you can browse your file system in dot notation...ish!
//Javascript's parser doesn't allow you to extract what you're looking for in dot notation, so we have to use a string instead
//Copyright 2017 - Josh Foster

//We are first going to require Node's built-in file system
var fs = require('fs');

//This function will setup our file system.
function setup() {

    //Pull in our setup.json file
    var data = require('./setup.json');
    return data;
}

//This function will be called to get a filepath
function find(str) {

    //Setting our passed in string as a variable. We're going to be doing a lot of work on it
    var path = str;

    //get data from setup function
    var data = setup();

    //Keywords for easier reading down below
    var defaultEnglish = data.words.default;
    var backEnglish = data.words.back;
    var currentEnglish = data.words.current;
    var beginningEnglish = data.words.beginning;

    //Set some variables for paths
    var dft = data.routes.default; //default
    var back = data.routes.back; //back one directory
    var current = data.routes.current; //current directory
    var beginning = data.routes.beginning; //root directory

    //We want to make sure that our argument starts with one of our keywords. If not, let's use the default one;
    if (
        (path.substr(0, defaultEnglish.length) != defaultEnglish) &&
        (path.substr(0, backEnglish.length) != backEnglish) &&
        (path.substr(0, currentEnglish.length) != currentEnglish) &&
        (path.substr(0, beginningEnglish.length) != beginningEnglish)
    ) {
        path = 'dft.' + path; //add default if nothing is found
    }

    //Replace the '.' with '/'
    path = path.split('.').join('/');

    //Replace the key words with correct routes
    path = path.split(defaultEnglish + '/').join(dft);
    path = path.split(backEnglish + '/').join(back);
    path = path.split(currentEnglish + '/').join(current);
    path = path.split(beginningEnglish + '/').join(beginning);

    //if we're not requesting a folder
    if (path.substr(path.length - 7) != '/folder' && path.substr(path.length - 2) != '/f') {
        //Remove all the . with / unless it's the last one
        path = path.replace(/\/(?=[^\/]*$)/, '.');
    }

    //if it's a folder
    else {
        if (path.substr(path.length - 1) === 'f') {
            path = path.substr(0, path.length - 2);
        } else {
            path = path.substr(0, path.length - 7);
        }
        path += '/';
    }

    //Return path
    return path;

}

function req(str , from) {
  if(str.substr(0, 4) === 'back' || str.substr(0, 7) === 'current'){
    if(from != 'log'){
      console.log('Gathering contest of a file currently does not work with relative paths. Try require(df.find(path)) instead or use an absolute path');
    }
    return 'Gathering contest of a file currently does not work with relative paths. Try require(df.find(path)) instead or use an absolute path';
  }
    return require(find(str));
}

function log(str) {
    console.log(req(str, 'log'));
}

exports.req = req;
exports.find = find;
exports.log = log;
